﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LibXom.Blocks
{
    public class StrsBlock : XomBlock
    {
        private int strsBufferSz;
        private int numStrs;
        private List<int> offsetList = new List<int>();
        private List<string> stringList = new List<string>();

        public int StringsSectionSz
        {
            get
            { 
                return strsBufferSz;
            }
        }
        public int NumStrs
        {
            get
            {
                return numStrs;
            }
        }
        public int[] OffsetList
        {
            get
            {
                return offsetList.ToArray();
            }
        }
        public string[] StringList
        {
            get
            {
                return stringList.ToArray();
            }
        }

        internal StrsBlock(int numStrs, int strsBufferSz, int[] offsetList, string[] stringList)
        {
            this.name = "STRS";
            this.numStrs = numStrs;
            this.strsBufferSz = strsBufferSz;

            this.offsetList.AddRange(offsetList);
            this.stringList.AddRange(stringList);
        }
    }
}
